;TSETPOPS.ASM -- Copyright 1995 Life Sciences Software

;    Routines callable from BASIC programs to trigger pop-up of TimeSet-TSR
;    in various modes. See TSETPOPS.TXT.

.Model Medium,BASIC
.Code
TsetAuto Proc             
    mov  ax,0aaaah        ;AAAA tells TsetTSR to pop up and start dialing
    mov  bx,0
    mov  es,bx            ;point to segment 0
    mov  di,41eh          ;point to offset 41E
    stosw                 ;Poke AAAA at 0000:041E for autodial after pop up
    call TsetManual       ;call for pop up by poking F0F0 at 0000:043C
    ret                   ;return to BASIC
TsetAuto Endp

TsetClock Proc
    mov ax,01111h         ;1111 tells TsetTSR to pop up big digital clock
    mov bx,0
    mov es,bx             ;point to segment 0
    mov di,41eh           ;point to offset 41EH
    stosw                 ;poke 1111 at 0000:041E for digital clock display
    call TsetManual       ;call for pop up by poking F0F0 at 0000:043C
    ret                   ;return to BASIC
TsetClock endp

TsetManual Proc           
    mov  ax,0f0f0h        ;F0F0 alone causes manual pop-up, but not if other
    mov  bx,0             ; values have been poked to 0000:041E
    mov  es,bx            ;point to segment 0
    mov  di,43ch          ;point to offset 043C
    stosw                 ;poke F0F0 at 0000:043C to cause pop up
    ret                   ;return to calling routine or to BASIC
TsetManual endp

BBtoDosUpdate Proc     
    mov  ax,0ddddh        ;DDDD tells TsetTSR to update DOS clock from B&B
    mov  bx,0
    mov  es,bx            ;point to segment 0
    mov  di,41eh          ;point to offset 41E
    stosw                 ;Poke AAAA at 0000:041E for autodial after pop up
    call TsetManual       ;call for pop up by poking F0F0 at 0000:043C
    ret                   ;return to BASIC
BBtoDosUpdate endp

BBtoDosUpdateNoLearn Proc ;Defeat RighTime learning for one B&B to DOS update
    mov ax,0fdb3h         ;Tell RighTime to turn off learning for 1 clock set
    mov bx,-1
    int 1ah
    call BBtoDosUpdate    ;now force pop-up for DOS clock update
    ret
BBtoDosUpdateNoLearn endp

End
